"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./index");
describe("keyboard manager", function () {
    it("should manage keyboard shortcuts", function () {
        var _a;
        var triggered = 0;
        var keyboard = new index_1.Keyboard();
        var event1 = { key: "a", metaKey: true };
        var event2 = { key: "0" };
        var handler = keyboard.getHandler();
        var listener = index_1.createShortcuts((_a = {},
            _a[index_1.stringifyKey("cmd", "a")] = function () {
                triggered++;
            },
            _a));
        keyboard.addListener(listener);
        handler(event1);
        handler(event2);
        keyboard.removeListener(listener);
        handler(event1);
        handler(event2);
        expect(triggered).toEqual(1);
    });
    it('should support a "global" pattern', function () {
        var _a, _b;
        var dispatcher = new index_1.Keyboard();
        var handler = dispatcher.getHandler();
        var appTriggered = 0;
        var globalTriggered = 0;
        var appKeyboard = new index_1.Keyboard();
        var globalKeyboard = new index_1.Keyboard();
        dispatcher.addListener(appKeyboard.getListener());
        dispatcher.addListener(globalKeyboard.getListener());
        globalKeyboard.addListener(index_1.createShortcuts((_a = {},
            _a[index_1.stringifyKey("cmd", "a")] = function () {
                globalTriggered++;
            },
            _a)));
        appKeyboard.addListener(index_1.createShortcuts((_b = {},
            _b[index_1.stringifyKey("a")] = function () {
                appTriggered++;
            },
            _b[index_1.stringifyKey("cmd", "a")] = function () {
                appTriggered++;
            },
            _b)));
        handler({ key: "a", metaKey: true });
        expect(appTriggered).toEqual(0);
        expect(globalTriggered).toEqual(1);
        handler({ key: "a" });
        expect(appTriggered).toEqual(1);
        expect(globalTriggered).toEqual(1);
    });
});
//# sourceMappingURL=index.spec.js.map